#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <time.h>

int startdome=0;
int stop_dome=0;
FILE *fp;
unsigned char bou[255],  bin[255], bb[255];
char v1[80];

struct tm *t;
time_t it;
char jtime[10]={0,0,':',0,0,':',0,0,'_',0};
char ss[3]={0,0,0},pp[3],mm[3]={0,32,0};
int expt=0;
float rect=0.;
int obsnum=-1;
int restime=0;
char b80[80];
int ontime=0;                    // 17:00-30:59 record down bjt,ra,de

getime()
{
  int i;
  char dummy[25];
  it=time(0);
  t=localtime(&it);
  strcpy(dummy,asctime(t));
  for(i=0;i<8;i++)jtime[i]=dummy[11+i];
}

static int set_com(int fd)
{
  struct termios jiang;
  jiang.c_cflag = 0x8bd;
  jiang.c_iflag = 1;
  jiang.c_lflag = 0x8040284;
  jiang.c_cc[VTIME] = 0;
  jiang.c_cc[VMIN]  = 0;
  tcflush(fd, TCIOFLUSH);           //clear buffer
  if(tcsetattr(fd, TCSANOW, &jiang)){perror("Failed to tcgetattr");return -1;}
  return 0;
}

checkv1(char *a)
{
  int k=0; char b=':', c='.';
  if(a[ 3]!=b)k++; if(a[ 6]!=b)k++; if(a[ 9]!=c)k++;
  if(a[13]!=b)k++; if(a[16]!=b)k++; if(a[19]!=c)k++;
  if(a[23]!=b)k++; if(a[26]!=b)k++; if(a[29]!=c)k++;
  if(a[34]!=b)k++; if(a[37]!=b)k++; if(a[40]!=c)k++;
  if(a[43]!=b)k++; if(a[46]!=b)k++; if(a[49]!=c)k++;
  return k;
}

main(int ac,char **av)
{
  int i,k,itc=3;
  int pac=0;
  int job=0, oldjob=0,wave,vv;
  int fd,c, res;
  char exps[67];
  float tems;
  if(ac>1){
    printf("\n\t ******* unix_n3  2014,5,7 ******");
    printf("\n\t Usage: unix_n3 [1,2] &\n");
  }
  if(ac>1)sscanf(av[1],"%d",&pac);  // pac=1 or 2. print more
  system("sudo chmod 777 /dev/ttyS0");
  k=getpid();
  system("ps ax |grep unix_n3 >/u/ccdev/jiang/n3.tmp");
  fp=fopen("/u/ccdev/jiang/n3.tmp","r");
l00:
  fgets(bou,80,fp); if(feof(fp))goto l01;
  res=strlen(bou); sscanf(bou,"%d",&i);
  if(res<60 && i!=k && bou[27]!='g'){
    sprintf(bb,"kill %d",i); system(bb);
  }
  goto l00;
l01:
  fclose(fp);

  fd = open("/dev/ttyS0", O_RDWR);
  if(fd <0 ){ perror("uart open err:"); return -1; }
  if(set_com(fd)){ printf("set_com failed!\n"); return -1; }

  fp=popen("/u/ccdev/jiang/vdbshow variables obsnum","r");
  fscanf(fp,"%d",&obsnum); pclose(fp);

  while (1) { sleep(1); itc++;  if(itc>=3)itc=0;
    if(itc==1) {    bou[0]=0;            k=0;
      if(startdome==1 || stop_dome==1){  k=1;
        if(startdome){ if(pac)printf("StartDome\n");
                       bou[1]='&'; startdome++; }
        if(stop_dome){ if(pac)printf("Stop_Dome\n");
                       bou[1]='$'; stop_dome++; }
      } else { 
        whatsend();            k=strlen(bou);
        if(k)for(i=k;i>0;i--)bou[i]=bou[i-1];
      }
      bou[k+1]=0;   bou[0]='`';
      write(fd,bou,k+1);
    }

    res=read(fd,bin,255);
    if (res>0 ) { bin[res]=0;
      for(i=0;i<res;i++){
        if(bin[i]=='"')bin[i]='.';
        if(bin[i]=='\'')bin[i]=':';
        if(bin[i]==32)bin[i]='_';
        if(bin[i]=='=')bin[i]='0';
      }
      if(res>69){               // if return messages append v1
        if(bin[69]!='`'){ for(i=0;i<res-69;i++)bin[i]=bin[i+69];
                          res-=69; bin[res]=0; }
      }
l60:
      if(res<54 || res>68){    // ignore wrong data
        if(bin[0]=='`'){           // v1 only
          if(checkv1(bin)){ res=60; goto l60; }  // ignore wrong data
        //  bin[34]=bin[37]=':'; bin[40]='.';
        //printf("%s\n",bin);
        //         1         2         3         4         5
        //123456789012345678901234567890123456789012345678901234567890
        //15:44:43.203:20:49.604:32:00.6-.5:.5:.5.22:48:49.0.5.5..AAAB
        //    printf("%d\n",bin[56]);       dome mark
        //  if(bin[56]=='0' || bin[56]=='1'){
// record down bjt,ra,de  17:00-30:59
	  i=bin[1]-48; i=i*10+bin[2]-48;
	  if(i<17 || i>30)ontime=0;
	  else {
            if(ontime==0){
              fp=fopen("/u/ccdev/smtlib/bjrade.dat","rb");
              if(fp!=0){ fseek(fp,0,2); i=ftell(fp)/1000; fclose(fp);} else i=0;
	      if(i>300)system("mv /u/ccdev/smtlib/bjrade.dat /u/ccdev/smtlib/bjrade.old");
	      system("date >> /u/ccdev/smtlib/bjrade.dat");
            }
            ontime=1;
            strncpy(bb,&bin[1],10); bb[10]=32; bb[11]=0;
            strncat(bb,&bin[21],19);
	    fp=fopen("/u/ccdev/smtlib/bjrade.dat","a");
	    fprintf(fp,"%s\n",bb);
	    fclose(fp);
	  }
if(pac)printf("%s",bin);
          strcpy(bb,"/u/ccdev/jiang/tdbset v1 "); strcat(bb,&bin[1]);
          system(bb);
          for(i=0;i<80;i++)v1[i]=bin[i+1];

          i=0;
          for(k=0;k<67;k++){
            if(k%10==0 && k!=0)bb[i++]=10;
            bb[i++]=bin[k+1]; if(k==53 || k==55)bb[i++]=32;
          }
          bb[i]=0;
          if(job!=3){
            fp=popen("/u/ccdev/jiang/tempshow","r");
            fscanf(fp,"%f",&tems); pclose(fp);
          }
          fp=popen("/u/ccdev/jiang/tdbshow vv","r");
          fscanf(fp,"%d",&vv);   pclose(fp);

          getime();
          k= ((jtime[0]-48)*10+jtime[1]-48)*3600;
          k+=((jtime[3]-48)*10+jtime[4]-48)*60;
          k+=((jtime[6]-48)*10+jtime[7]-48);
          getexpo(exps,k);
if(pac>1)printf("%s  job: %d\n",exps,job);
          fp=fopen("/u/ccdev/status/telescope.txt","w");
          fprintf(fp,"%s\n",bb);
          k=tems;
          fprintf(fp,"%04d.%02d\n",k,vv);
          fprintf(fp,"%s\n",exps);
          fclose(fp);

          k=strlen(exps);
          job=2;
          if(k==29)job=1;             // 22+7
          if(k==66)job=3;

          if(job==1)if(restime>0 && restime<25){ stop_dome++; startdome=0; }
          if(job==2)rect+=3.1; else rect=0.;
          if(job==3){ stop_dome=0;  startdome++; } 

          if(job!=oldjob){
            sscanf(&bb[63],"%d",&wave);
            if(wave>9999)wave=0;
            if(job==1){
              checkname(wave,vv);
              system("/u/ccdev/jiang/tdbset pp 00");
              system("/u/ccdev/jiang/tdbset ss 00");
            }
            if(job==3){
              unlink("/u/ccdev/status/job.txt");
              if(obsnum>=0){
                sprintf(b80,"/u/ccdev/jiang/addfit2 %d &\n",obsnum);
                system(b80);
              }
            }
          }
          oldjob=job;
        } else {                   // rec.  return_message
          getime();
          printf("R: %s                      %s",jtime,bin);
          if(bin[0]=='t' && bin[1]=='i'){    // time
	    getclock();
            write(fd,bou,strlen(bou));
	  } else {
            sleep(1);
            strcpy(bb,"/u/ccdev/jiang/tdbshow pp");
            fp = popen(bb,"r"); fread(pp,1,2,fp); pclose(fp);
            pp[0]++; mm[0]=pp[0]=(pp[0]&3)|0x30; pp[2]=0;
            strcpy(bb,"/u/ccdev/jiang/tdbset p"); strcat(bb,mm);
                              strcat(bb,jtime);  strcat(bb,bin);
            system(bb);
            strcpy(bb,"/u/ccdev/jiang/tdbset pp "); strcat(bb,pp);
            system(bb);
	  }
        }
      }
    }
  }
}

whatsend()
{
  int i,res; FILE *fp;
  char cal[13],cde[13];
  float al,de,epoch;
  if(ss[0]==ss[1]){
    strcpy(bb,"/u/ccdev/jiang/tdbshow ss");
    fp = popen(bb,"r"); fread(ss,1,2,fp); pclose(fp);
  }
  if(ss[0]!=ss[1]){
    ss[1]++; mm[0]=ss[1]=(ss[1]&3)|0x30; ss[2]=0;
    strcpy(bb,"/u/ccdev/jiang/tdbshow s"); strcat(bb,mm);
    fp = popen(bb,"r"); res=fread(bou,1,128,fp); pclose(fp);
    for(i=0;i<res;i++)if(bou[i]=='_')bou[i]=32; bou[res]=0;
    if(bou[0]=='m' && bou[1]=='o'){
      i=itohd(&bou[5],&al,&de,&epoch);
      zoms(al,cal,1); zoms(de,cde,0);
      if(epoch<1950. || epoch >2050.)epoch=2000.0;
      if(epoch!=2000.)sprintf(&bou[4],"%s %s %6.1f\012",cal,cde,epoch);
      else            sprintf(&bou[4],"%s %s\012",cal,cde);
    }
    strcpy(bb,"/u/ccdev/jiang/tdbset ss "); strcat(bb,ss);
    system(bb);
  } else {
    fp = fopen("/u/ccdev/jiang/xydw","r");
    if(fp!=0){   /* xydw 123 456 */
      fgets(bou,80,fp);
      fclose(fp);
      unlink("/u/ccdev/jiang/xydw");
    }
  }  
}	

getclock()
{
  int i=0;
  char dummy[25],d;
  it=time(0); t=localtime(&it); strcpy(dummy,asctime(t));
  d=dummy[18]; 
wait:
  it=time(0); t=localtime(&it); strcpy(dummy,asctime(t));
  if(dummy[18]==d){ i++; goto wait; }
  bou[0]='`';
  bou[1]=dummy[11]; bou[2]=dummy[12];
  bou[3]=dummy[14]; bou[4]=dummy[15];
  bou[5]=dummy[17]; bou[6]=dummy[18];
  bou[7]=10;        bou[8]=0;
//  printf("%8d %s",i,dummy);
}

zoms(fa,cc,k)
/*
c hour or degree to char_line
c if k=1 (hour case) in **:**:**.*
c    k=0 (degree       -**:**:**
*/
char cc[12];
float fa;
int k;
{
  int i,j,m,n;
  float a,x;
  a=fa; if(a < 0.)a=-a;
  i=a; x=(a-i)*60.;
  j=x; x=(x-j)*60.;
  m=x;
  n=(x-m)*10.+0.5;
  if(k == 0)   n=n+5;
  if(n >= 10) { m++;  n=0; }
  if(m == 60) { j++;  m=0; }
  if(j == 60) { i++;  j=0; }
  sprintf(cc," %02d:%02d:%02d.%d\0",i,j,m,n);
  cc[0]=(fa<0.)?'-':' ';
  if(k==0)cc[9]=0;
}

itohd(cc,alpha,delta,epoch)
/*
c 12:23 -23:00:2.3 1950 in a char_line  give value to 3 avariable
c 12:23 -23:00:2.3 is also ok, but last avariable get zero value
c 12:34:23.5 to 12.578567
*/
char cc[];
float *alpha,*delta,*epoch;
{
  int i,j,k,k1,k2;
  float al,de,ep,x,y,z;
  char dd[20];
//  k=index(cc,' ');
  for(k=0;k<20;k++)if(cc[k]==32)break;
  if(k < 0 || k > 13)goto a100;
  strncpy(dd,cc,k); dd[k]=0;
  for(i=0;i<10;i++)if(dd[i]==':')dd[i]=32;
  al=de=ep=x=y=z=0;
  sscanf(dd,"%f%f%f",&x,&y,&z);
  al=x+y/60.+z/3600.;
  for(i=k+1;i<k+6;i++)if(cc[i] != ' ')goto a17;
  goto a100;
a17:
  strcpy(dd,&cc[i]);
//  k=index(dd,' ');
  for(k=0;k<20;k++)if(dd[k]==32)break;
  if(k > 0 ){
    sscanf(&dd[k+1],"%f",&ep);
    dd[k]=0;
    if(ep<1950. || ep>2050.)ep=2000.;
  } 
  for(i=0;i<=10;i++)if(dd[i]==':')dd[i]=32;
  x=y=z=0;
  sscanf(dd,"%f%f%f",&x,&y,&z);
  de=x+y/60.+z/3600.;
  if(x<0 || dd[0]=='-')de=x-y/60.-z/3600.;   /* 94,1,21 add "dd[0].." */
  if(ep>2100)goto a100;
  *alpha=al;
  *delta=de;
  *epoch=ep;
  return(1);
a100:
  return(0);
}

getexpo(s,bt)
char *s; int bt;
{
  FILE *fp,*fp1;
  char ss[999];
  int i,j,k,l,m,a[8];
  fp=popen("/u/ccdev/jiang/showexp","r");
  ss[fread(ss,1,528,fp)]=0;
  pclose(fp);

  k=2;    for(i=0;i<8;i++,k+=66) a[i]=val(&ss[k]);
  m=a[0]; i=0; for(l=1;l<8;l++)if(m<a[l]){ i=l; m=a[l]; }
  j=val(&ss[i*66+24]);
  k=val(&ss[i*66+46]);
//printf("obsnum: %d, %d %d %d %d\n",obsnum,i,a[i],j,k);
  m=i*66;  for(l=0;l<22;l++)s[l]=ss[m+l];

  m= ((s[11]-48)*10+s[12]-48)*3600;
  m+=((s[14]-48)*10+s[15]-48)*60;
  m+=((s[17]-48)*10+s[18]-48);
  m=bt-m; if(m<0)m+=86400; m=expt-m; 
  sprintf(&s[21],"%8d",m);  restime=m;
                                             //     s[21]=32; s[22]=0;
  if(j>=a[i]){
    m=i*66+22; for(l=0;l<22;l++)s[l+22]=ss[m+l]; // s[43]=32; s[44]=0;
    if(rect<999. &&  rect>0.) sprintf(&s[43],"%8d",(int)rect);
    else        { s[43]=32; s[44]=0; }
    if(k>=j){
      m=i*66+44; for(l=0;l<22;l++)s[l+44]=ss[m+l]; s[65]=32; s[66]=0;
    }
  }
}

val(ss)
char *ss;
{
  int k=0;
  k= (ss[0]-48)*10+ss[1]-48; k*=100;
  k+=(ss[3]-48)*10+ss[4]-48; k*=100;
  k+=(ss[6]-48)*10+ss[7]-48; k*=100;
  k+=(ss[9]-48)*10+ss[10]-48; k*=100;
  k+=(ss[12]-48)*10+ss[13]-48;
  return(k);
}

checkname(filt,vv)
int filt,vv;
{
  FILE *fp;
  int i,k;
  int sizx,sizy;
  char a[80],b[80],color;

  fp=fopen("/u/ccdev/FILTER","r");
l10:
  fgets(b,80,fp); if(feof(fp)!=0){ fclose(fp); color=32; goto l11; }
  sscanf(&b[2],"%d",&k); if(k!=filt)goto l10;
  fclose(fp); color=b[0];
l11:
  fp=popen("/u/ccdev/jiang/vdbshow variables obsnum","r");
  fscanf(fp,"%d",&obsnum); pclose(fp);
  fp=popen("/u/ccdev/jiang/vdbshow object 0","r");
  k=fread(a,1,80,fp); pclose(fp);
  a[k]=0;
  fp=fopen("/u/ccdev/NAME","r");
  fgets(b,80,fp);
l20:
  fgets(b,80,fp);
  if(feof(fp)){ fclose(fp);
    strcpy(b,"NONE\n");
    strncat(b,&v1[20],10); strcat(b," ");
    strncat(b,&v1[30],10); strcat(b,"\n");
    strcat(b,a);
    goto l90;
  }
  for(i=0;i<k;i++)if(a[i]!=b[i+36])goto l20;
  fclose(fp);
  b[4]=b[35]=10;

l90:
  fp=fopen("/u/ccdev/status/netjob.log","r"); fgets(a,80,fp); fclose(fp);
  fp=popen("/u/ccdev/jiang/vdbshow exposure 0","r");
  fscanf(fp,"%d",&expt); pclose(fp); expt/=100;
  fp=popen("/u/ccdev/jiang/vdbshow nr 0","r");
  fscanf(fp,"%d",&sizx); pclose(fp);
  fp=popen("/u/ccdev/jiang/vdbshow nc 0","r");
  fscanf(fp,"%d",&sizy); pclose(fp);

  fp=fopen("/u/ccdev/status/job.txt","w");
  fprintf(fp,"%03d",obsnum);
  if(vv<=10) fprintf(fp,"\n"); else  fprintf(fp," %s",a);
  fprintf(fp,"%s",b);
  if(filt!=0)fprintf(fp,"%d %c\n",filt,color); else fprintf(fp,"?\n");
  fprintf(fp,"%d\n",expt);
  fprintf(fp,"%d x %d\n",sizx,sizy);
  fclose(fp);
}
